﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.Windows.Forms.DataVisualization.Charting;
using System.IO;
using System.Text.RegularExpressions;


// observatie numarul precipitatiilor e hardcodat ( adica am luat un vector de dimensiune 3 ) -trb modificat pt a 
// avea aplicatia cat mai generala

namespace Data4WaterProject
{
    public partial class Form1 : Form
    {

        ParseFileBazin fileBazin = new ParseFileBazin(@"C:\HEC-HMS\Siron\Siron\Siron_subbasin.basin");
        public Form1()
        {
            InitializeComponent();

            /*Chart precipitation */
                ReadPrecipitation Precipitation = new ReadPrecipitation();
                Precipitation.citire_date_din_fisier();
                Precipitation.citire_date();
                ChartPrecipitation.Series["FPrecipitation"].Points.DataBindXY(Precipitation.vector_date_timp, Precipitation.vector_init_precipitatii);
                ChartPrecipitation.Series["VPrecipitation"].Points.DataBindXY(Precipitation.vector_date_timp, Precipitation.vector_init_precipitatii);
            

                ReadDataFile reader = new ReadDataFile();
                reader.ReadParametersFromFile(@"C:\HEC-HMS\CurveNumber\", @"50",ChartFlow);
                ChartFlow.Update();
                


        }

        private void Panel_Paint(object sender, PaintEventArgs e)
        {
        }

        private void checkBoxA_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void trackBarA_Scroll(object sender, EventArgs e)
        {

            if (checkA.Checked == true)
            {
                try
                {
                    string newValue = Convert.ToString(trackBarA.Value);
                    valueA.Text = newValue;
                    ReadDataFile reader = new ReadDataFile();


                    reader.ReadParametersFromFile(@"C:\HEC-HMS\CurveNumber\", newValue, ChartFlow);
                    ChartFlow.Update();

                    fileBazin.ChangeCurveNumber(newValue);
                }
                catch (Exception ex)
                {
                    Console.WriteLine("The process failed: {0}", ex.ToString());
                }
            }
        }

        private void labelA_Click(object sender, EventArgs e)
        {

        }

        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            Process proc = null;
            string auxiliar = "";
            string path = @"C:\HEC-HMS\RunSimulation.txt";
            double Num;
            bool isNum;
            int count = 0;
            int incrementare = 0;

            try
            {


                string batDir = string.Format(@"C:\HEC-HMS");
                proc = new Process();
                proc.StartInfo.WorkingDirectory = batDir;
                proc.StartInfo.FileName = "hec.bat";
                proc.StartInfo.CreateNoWindow = true;
                proc.Start();
                proc.WaitForExit();


                batDir = string.Format(@"C:\HEC-HMS");
                proc = new Process();
                proc.StartInfo.WorkingDirectory = batDir;
                proc.StartInfo.FileName = "runSim.bat";
                proc.StartInfo.CreateNoWindow = true;
                proc.Start();
                proc.WaitForExit();

                //aici sa nu afisam acest mesaj (msj e bun pentru a intelege noi )
                MessageBox.Show("Bat file executed !!");


                // aici trebuie sa fie updatate chart1 grafic adica ala cu flowul
                // check if we have the curve number`s box thicked
                /*
                // here we update the graph such that the illusion that real time is until the results are processed
                while (incrementare <= 100) // until the process is finished we continually change the graphics
                {

                    //clear points from the chart
                    ChartFlow.Series["Flow"].Points.Clear();
                    ChartFlow.Series["FlowBased"].Points.Clear();
                    ChartFlow.Series["FlowObserved"].Points.Clear();

                    using (StreamReader sr = new StreamReader(path))
                    {
                        while (sr.Peek() >= 0)
                        {
                            auxiliar = String.Copy(sr.ReadLine());
                            foreach (var lineItem in auxiliar.Split())
                            {

                                isNum = double.TryParse(lineItem, out Num);
                                if (isNum)
                                {
                                    count += 1;
                                    incrementare += 1;

                                    if (count % 3 == 0)
                                    {
                                        //Console.WriteLine(lineItem);
                                        // MaxFlow_vector[incrementare] = float.Parse(lineItem);
                                        ChartFlow.Series["FlowObserved"].Points.AddY(float.Parse(lineItem));
                                    }
                                    if (count % 4 == 0)
                                    {
                                        //Console.WriteLine(lineItem);
                                        ChartFlow.Series["Flow"].Points.AddY(float.Parse(lineItem));
                                        // MinFlow_vector[incrementare] = float.Parse(lineItem);

                                    }
                                    if (count % 5 == 0)
                                    {
                                        //Console.WriteLine(lineItem);
                                        ChartFlow.Series["FlowBased"].Points.AddY(float.Parse(lineItem));
                                        //MeanFlow_vector[incrementare] = float.Parse(lineItem);
                                    }

                                }
                            }
                            count = 0;
                        }
                    }
                    ChartFlow.Update();


                    //modificam path-ul a.i sa cream ilusia de real time

                    incrementare += 1;
                }
               */

                //we reset the counter //from here we process the real data
                incrementare = 0;

                 //clear points from the chart
                ChartFlow.Series["Flow"].Points.Clear();
                ChartFlow.Series["FlowBased"].Points.Clear();
                ChartFlow.Series["FlowObserved"].Points.Clear();

                using (StreamReader sr = new StreamReader(path))
                {
                    while (sr.Peek() >= 0)
                    {
                        auxiliar = String.Copy(sr.ReadLine());
                        foreach (var lineItem in auxiliar.Split())
                        {

                            isNum = double.TryParse(lineItem, out Num);
                            if (isNum)
                            {
                                count += 1;
                                incrementare += 1;

                                if (count % 3 == 0)
                                {
                                    //Console.WriteLine(lineItem);
                                    // F_vector[incrementare] = float.Parse(lineItem);
                                    ChartFlow.Series["FlowObserved"].Points.AddY(float.Parse(lineItem));
                                }
                                if (count % 4 == 0)
                                {
                                    //Console.WriteLine(lineItem);
                                    ChartFlow.Series["Flow"].Points.AddY(float.Parse(lineItem));
                                    // MinFlow_vector[incrementare] = float.Parse(lineItem);

                                }
                                if (count % 5 == 0)
                                {
                                    //Console.WriteLine(lineItem);
                                    ChartFlow.Series["FlowBased"].Points.AddY(float.Parse(lineItem));
                                    //MeanFlow_vector[incrementare] = float.Parse(lineItem);
                                }

                            }
                        }
                        count = 0;
                    }
                }
                ChartFlow.Update();

            

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.StackTrace.ToString());
            }
        }


        private void trackBarPrecit_Scroll(object sender, EventArgs e)
        {
            try
            {
                if (checkPrecit.Checked == true)
                {

                    ReadPrecipitation Precipiation = new ReadPrecipitation();
                    Precipiation.citire_date_din_fisier();
                    Precipiation.citire_date();

                    float ValPrecpit;
                    float[] vector_final_precipitatii = new float[3];
                    ValPrecpit = trackBarPrecit.Value;

                    //sterg punctele existente din variable_precipitation series ca sa fac loc pentru altele
                    ChartPrecipitation.Series["VPrecipitation"].Points.Clear();

                    for (int element = 0; element < Precipiation.vector_init_precipitatii.Length; element++)
                    {
                        vector_final_precipitatii[element] = ValPrecpit * Precipiation.vector_init_precipitatii[element] / 100;
                    }
                    ChartPrecipitation.Series["VPrecipitation"].Points.DataBindXY(Precipiation.vector_date_timp, vector_final_precipitatii);

                    //updatez graficul Flow
                    ReadDataFile reader = new ReadDataFile();

                    reader.ReadParametersFromFile(@"C:\HEC-HMS\Precipitation\", Convert.ToString(ValPrecpit), ChartFlow);
                    ChartFlow.Update();
 

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Eroarea este:" + ex.Message);
            }

        }

        private void labelPrecit_Click(object sender, EventArgs e)
        {

        }

        private void checkPrecit_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void chart1_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void panelA_Paint(object sender, PaintEventArgs e)
        {
            /*
            Graphics graphic = panelA.CreateGraphics();
            Pen pen = new Pen(Color.Blue, 2);
            graphic.DrawEllipse(pen, 213, 10, 50, 50); 
             * */
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            if (checkB.Checked == true)
            {
                try
                {
                    double newValue = Convert.ToDouble(trackBarB.Value) / 10;
                    string newValueString = Convert.ToString(newValue);
                    valueB.Text = newValueString;
                    ReadDataFile reader = new ReadDataFile();


                    reader.ReadParametersFromFile(@"C:\HEC-HMS\SnyderLag\", newValueString, ChartFlow);
                    ChartFlow.Update();

                    fileBazin.ChangeSnyderTP(newValueString);
                }
                catch (Exception ex)
                {
                    Console.WriteLine("The process failed: {0}", ex.ToString());
                }
            }
        
        }

        private void panelB_Paint(object sender, PaintEventArgs e)
        {
            /*
            Graphics graphic = panelB.CreateGraphics();
            Pen pen = new Pen(Color.Blue, 2);
            graphic.DrawEllipse(pen, 213, 10, 50, 50); 
             * */
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void trackBar1_Scroll_1(object sender, EventArgs e)
        {


            if (checkC.Checked == true)
            {
                try
                {
                    double newValue = Convert.ToDouble(trackBarC.Value) / 100;
                    string newValueString = Convert.ToString(newValue);
                    valueC.Text = newValueString;
                    ReadDataFile reader = new ReadDataFile();


                    reader.ReadParametersFromFile(@"C:\HEC-HMS\RecessionConstant\", newValueString, ChartFlow);
                    ChartFlow.Update();

                    fileBazin.ChangeRecessionFactor(newValueString);
                }
                catch (Exception ex)
                {
                    Console.WriteLine("The process failed: {0}", ex.ToString());
                }

            }
        }

        private void panelC_Paint(object sender, PaintEventArgs e)
        {
            /*
            Graphics graphic = panelC.CreateGraphics();
            Pen pen = new Pen(Color.Blue, 2);
            graphic.DrawEllipse(pen, 213, 10, 50, 50);
             * */
        }

        private void labelDescriptionB_Click(object sender, EventArgs e)
        {

        }

        private void checkB_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void valueA_Click(object sender, EventArgs e)
        {

        }


    }
}
