﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;


namespace Data4WaterProject
{
    class ParseFileBazin
    {

        private static string pathToFile;

        public ParseFileBazin(string pathToFile)
        {
            ParseFileBazin.pathToFile = String.Copy(pathToFile);
        }

        public static void lineChanger(string newText,int line_to_edit)
        {
            string[] arrLine = File.ReadAllLines(pathToFile);
            arrLine[line_to_edit] = newText;
            File.WriteAllLines(pathToFile, arrLine);
        }

        public static int findLine(string match)
        {
            string line;
            int lineCounter = 0;

            StreamReader file = new StreamReader(pathToFile);

            while ((line = file.ReadLine()) != null)
            {

                if (line.Contains(match))
                    break;

                lineCounter++;

                //System.Console.WriteLine(line);
            }
            file.Close();

            //Console.WriteLine(lineCounter);

        return lineCounter;
        }

        public void ChangeCurveNumber(string ValueToChange)
        {
            string match = "Curve Number";
            /* string to be written */
            string newText ="\t " + match + ": " + ValueToChange;
            int lineNumber = findLine(match);

            lineChanger(newText, lineNumber);
  
        }

        public void ChangeSnyderTP(string ValueToChange)
        {
            string match = "Snyder Tp";
            /* string to be written */
            string newText = "\t " + match + ": " + ValueToChange;
            int lineNumber = findLine(match);

            lineChanger(newText, lineNumber);

        }

        public void ChangeRecessionFactor(string ValueToChange)
        {
            string match = "Recession Factor";
            /* string to be written */
            string newText = "\t " + match + ": " + ValueToChange;
            int lineNumber = findLine(match);

            lineChanger(newText, lineNumber);

        }



    }
}
