﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms.DataVisualization.Charting;

namespace Data4WaterProject
{
    class ReadDataFile
    {
        public void ReadParametersFromFile(string path, string newValue, Chart chart1)
        {
            string auxiliar = "";
            //string path = @"C:\HEC-HMS\CurveNumber\";
            double Num;
            bool isNum;
            int count = 0;
            int ink = 0;
            path = path + newValue + ".txt";

            //clear points from the chart
            chart1.Series["Flow"].Points.Clear();
            chart1.Series["FlowBased"].Points.Clear();
            chart1.Series["FlowObserved"].Points.Clear();

            using (StreamReader sr = new StreamReader(path))
            {
                while (sr.Peek() >= 0)
                {
                    auxiliar = String.Copy(sr.ReadLine());
                    foreach (var lineItem in auxiliar.Split())
                    {
                        isNum = double.TryParse(lineItem, out Num);
                        if (isNum)
                        {
                            count += 1;
                            ink += 1;

                            if (count % 3 == 0)
                            {
                                //Console.WriteLine(lineItem);
                                // MaxFlow_vector[incrementare] = float.Parse(lineItem);
                                chart1.Series["FlowObserved"].Points.AddY(float.Parse(lineItem));
                            }
                            if (count % 4 == 0)
                            {
                                //Console.WriteLine(lineItem);
                                chart1.Series["Flow"].Points.AddY(float.Parse(lineItem));
                                // MinFlow_vector[incrementare] = float.Parse(lineItem);

                            }
                            if (count % 5 == 0)
                            {
                                //Console.WriteLine(lineItem);
                                chart1.Series["FlowBased"].Points.AddY(float.Parse(lineItem));
                                //MeanFlow_vector[incrementare] = float.Parse(lineItem);
                            }

                        }
                    }
                    count = 0;
                }
            }
        }
    }
        public class ReadPrecipitation //pt a putea opera cu precipitatiile
        {
            // aici am facut o clasa pentru a putea pastra informatiile in vectoriul init de precipitatii
            // aici putem citi vectorul asta dintr-un fisier a.i sa avem valorile necesare pentru operatiile ulterioare 
            public float[] vector_init_precipitatii = new float[3];
            public string[] vector_date_timp = new string[3];

            public ReadPrecipitation()
            {
                vector_init_precipitatii[0] = 0;
                vector_init_precipitatii[1] = 1;
                vector_init_precipitatii[2] = 2;
            }

            public void citire_date_din_fisier()
            {
                // citire din fisierul Precipitation.txt
                try
                {
                    string auxiliar = "";
                    string path = @"C:\HEC-HMS\Siron\Precipitation.txt";
                    double Num;
                    bool isNum;
                    int count = 0;
                    int incrementare = 0;
                    using (StreamReader sr = new StreamReader(path))
                    {
                        while (sr.Peek() >= 0)
                        {
                            // Console.WriteLine(sr.ReadLine());

                            //}
                            auxiliar = String.Copy(sr.ReadLine());
                            foreach (var lineItem in auxiliar.Split())
                            {


                                isNum = double.TryParse(lineItem, out Num);
                                if (isNum)
                                {
                                    count += 1;
                                    if (count % 3 == 0)
                                    {
                                        vector_init_precipitatii[incrementare] = float.Parse(lineItem);
                                        incrementare += 1;
                                    }
                                }
                            }
                        }
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("The process failed: {0}", e.ToString());
                }

            }

            public float read_date(int i)
            {
                return vector_init_precipitatii[i];
            }

            public void citire_date()
            {
                try
                {
                    string auxiliar = "";
                    string path = @"C:\HEC-HMS\Siron\Precipitation.txt";
                    int count = 0;
                    int incrementare = 0;
                    string ajutator = "";
                    using (StreamReader sr = new StreamReader(path))
                    {
                        while (sr.Peek() >= 0)
                        {

                            auxiliar = String.Copy(sr.ReadLine());
                            foreach (var lineItem in auxiliar.Split())
                            {
                                if (count < 4)
                                {
                                    ajutator = ajutator + lineItem + " ";
                                    count += 1;
                                }
                            }

                            vector_date_timp[incrementare] = ajutator;
                            incrementare += 1;
                            count = 0;
                            ajutator = "";
                        }
                    }


                }
                catch (Exception e)
                {
                    Console.WriteLine("The process failed: {0}", e.ToString());
                }
            }
        }
    }
